package extensions;

import java.io.IOException;
import java.io.File;

import java.net.URL;
import java.net.Socket;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Config;
import dareka.common.CloseUtil;
import dareka.common.Logger;
import dareka.extensions.Extension;
import dareka.extensions.Rewriter;
import dareka.extensions.RequestFilter;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.Resource;
import dareka.processor.URLResource;
import dareka.processor.StringResource;
import dareka.processor.Processor;
import dareka.processor.TransferListener;
import dareka.processor.impl.Cache;

/*
 *
 */
public class localNicoPlayerExtension implements Extension, Processor {

	// Extension interface
	public Object queryInterface(Extension.Type type) {
		if (type == Extension.Type.Extension1)
			return (Extension) this;
		if (type == Extension.Type.Processor1)
			return (Processor) this;
		return null;
	}

	public String getVersionString() {
		return "localNicoPlayerExtension beta1";
	}

/* RXgN^Aݒ (fin) */
/***************************************************************************/

	public localNicoPlayerExtension() throws IOException {
		if (Config.getString("localNicoPlayer", "false").equals("true")) {
			Logger.info(" localNicoPlayer on.");
		} else {
			Logger.info(" localNicoPlayer off.");
		}
	}

/* ProcessorubN (fin) */
/*****************************************************************************/
	// Processor Interface
    private static final String[] PROCESSOR_SUPPORTED_METHODS =
        new String[] { "GET" };

	public String[] getSupportedMethods() {
	    return PROCESSOR_SUPPORTED_METHODS;
	}

    private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"^http://(?:www|res)\\.nicovideo\\.jp/swf/(?:nico|flv)player\\.swf.*");

	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}

	public String getSupportedURLAsString() {
		return null;
	}


/*
 *
 */
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		
		if (Config.getString("localNicoPlayer", "false").equals("true")) {
			File file = new File("local", "nicoplayer.swf");
			if (file != null && file.exists()) {
				return Resource.get(Resource.Type.URL, file.toURI().toString());
			}
			Logger.info("no \"local/nicoplayer.swf\" found. use niconico-default.");
		}
		return new URLResource(requestHeader.getURI());
	}

}


